# Power Budget

This repository contains the **power budget analysis** and relevant tools for the AcubeSAT project.

## Repository organisation

### Folders & Additional files
- `analyses`: Contains outputs produced by STK's power generation tool, which are fed into the script to calculate the stored power
- `efficiencies`: Contains comma-separated values of the board efficiencies for different EPS boards under different voltage/current/power conditions
- `lib`: Source for commonly-used python functions
- `outputs`: Default directory for all analysis results
- `scenarios`: A list of scenarios containing different modes, timelines and settings for the simulation

### Scripts
- `power_budget.py`: Performs and outputs the complete power analysis
- `power_budget_complete_plot.py`: Outputs the results of multiple analysis in common plots
- `stk-conditioning.py`: Converts `.dat` files produced by STK to a more readable `.csv` format
- `run_experiments.sh`: Bash script to run multiple power budget calculations at once

### Spreadsheets
- `Power_Budget.xlsx`: Summary of the power analysis results for different orbits & configurations
- `SatNOGS_board_components.xlsx`: Detailed analysis of the [SatNOGS Comms](https://gitlab.com/librespacefoundation/satnogs-comms/) power consumption for different operating profiles

### `power_budget`.py

The main power budget calculating script. It reads power generation values for every panel and every time point in orbit, assigns the outputs to MPPTs, and plots the power generation and power consumption during the entire orbit.

## Example output
![4 sample graphs of power_budget.py, showing instantaneous power, average power, dynamic MPPT efficiency, and discharge in orbit](screenshot.png)

## Features
- Reads power generation orbit data generated by STK
- Applies interpolated MPPT efficiencies according to a predefined cell-panel-MPPT assignment
- Generates instantaneous power plots
- Generates plots for OAP during the entire orbit
- Finds eclipse and sunlight durations
- Generates power storage plots
- Saves all generated plots in `.pdf` files, and results in `.json` files
- Supports different mission modes/phases with different power consumption and attitude values

## Usage instructions
0. You need to have **Python 3** installed
1. Install the required packages by running:
    ```bash
    pip install -r requirements.txt
    ```
2. Get a CSV file from STK, editing it as shown in the [Power Generation section](#power-generation)
3. Run the script:
    ```bash
    python power_budget.py scenarios/EPS_example.yml
    ```
4. Run `python power_budget.py --help` to see additional options. For example, to add additional attributes:
    ```bash
    python power_budget.py scenarios/EPS_example.yml -a orbit:SSO attitude:20deg
    ```
5. After running `power_budget.py` for multiple CSV files, you can generate a complete diagram by running:
    ```bash
    python power_budget_complete_plot.py
    ```

### Help message
```
usage: power_budget.py [-h] [--eclipse] [--hide-plots] [--output OUTPUT] [--output-dir OUTPUT_DIR] [--fast-mppt] [--demo] [--debug] [--attr ATTR [ATTR ...]] scenario [scenario ...]

Power Generation Budget

positional arguments:
  scenario              The .yml scenario file. If multiple files are provided, they are loaded consecutively.

optional arguments:
  -h, --help            show this help message and exit
  --eclipse             Generate eclipse/sunlight time statistics
  --hide-plots          Do not display and pause for plots
  --output OUTPUT, -o OUTPUT
                        The title of the files to store the plot outputs and PDFs. Is generated automatically if not provided
  --output-dir OUTPUT_DIR
                        The output directory of generated files and PDFs
  --fast-mppt           Perform less accurate but faster MPPT calculations
  --demo                Perform instant demo calculations for testing purposes
  --debug, -d           Enable debug logging
  --attr ATTR [ATTR ...], -a ATTR [ATTR ...]
                        Override an attribute from the scenario. Provide valid YAML/JSON as input
```

**Usage example:**
```bash
python power_budget.py scenarios/EPS_example.yml scenarios/Sun_Pointing.yml --fast-mppt
```

That will load the `EPS example` scenario, which includes a few basic variables for your EPS, and then load the `Sun Pointing` scenario, which includes a basic mission profile for AcubeSAT's orbit.

## Power Generation

The data used by the `power_budget.py` tool originate from STK's Solar Panel Tool. The following instructions shall be used when working with the Solar Panel Tool in STK to correctly extract the data:

1. In the Solar Panel Tool page, after computing, select **Graph** and click **Generate**.
2. **Right-click** on the graph -> **Export Dialog**.
3. Select **output folder**, data type `.dat` and click export.
4. Export using **comma** as the delimiter and use **maximum precision**.

After you have obtained the `.dat` file, run the following to convert it to a python-readable `.csv` file:
```bash
./stk-conditioning.py file.dat
```
